#!/usr/bin/env ruby

def count_tabs(str,tab)
  tabs = 0
  left = 0
  for right in 0..str.size-1
    if(str.slice(left..right) == tab)
      tabs += 1
      left = right+1
    end
  end
  return tabs
end

def tab_test(str)
  pass = true
  add = ["program","for","while","if","fun"]
  sub = ["endprogram","endfor","endwhile","endif","endfun"]
  file = File.new(str, "r")
  wanted = 0
  tab = 0

  while(line = file.gets)
    if(/^[ \t]+\w+/ =~ line)
      tab = line.match(/(\s+)\w+/)[1]
      if(line.match(/\s+(\w+)/)[1] == "program")
        wanted = 1
      end
      break
    end
  end
  file.close

  file = File.new(str, "r")
  row = 0
  while(line = file.gets)
    row += 1

    if(/^\s+$/ =~ line)
      next
    end

    if(/^\s*\/\/.*/ =~ line)
      next
    end

    key = line.match(/#{tab}*(\/*\w+)/)[1]
    tabs = line.match(/(#{tab}*)\w+/)[1]
    found = 0

    if(key.slice(0,2) == "//")
      next
    end

    if(sub.include?(key))
      wanted -= 1
    end

    if(key != "else")
      found = count_tabs(tabs,tab)
    else
      found = count_tabs(tabs,tab)+1
    end

    if(found != wanted)
      raise "TTParser:<Line #{row}> Expected #{wanted} indent(s), found #{found}!"
      pass = false
      break
    end

    if(add.include?(key))
      wanted += 1
    end

    if(key == "endprogram")
      pass = true
      break
    end

  end
  file.close
  return pass
end

